/* VISTA DE LA RUTA: /closeGuide - CIERRE DE PARRLLA */
<template>
	<div class="margin-0-4">
		<header style="margin:10rem 0 0">
			<ReturnButton :spanTitle="2" title="Regresar" @clickEvent="goTo('views')"></ReturnButton>
			<!-- Subtítulo -->
      <el-col :span="24">
        <div class="titleSection">CIERRE DE PARRILLA - {{channelTransmition}}</div>
      </el-col>
		</header>


    <div style="margin:3rem 7rem">
      <el-row>
        <el-col>
      		<el-date-picker  @change="changeDayClose(dateSearch)" 
            class="date-head m-b-15" v-model="dateSearch"
            type="date" format="dd/MM/yyyy" 
            value-format="timestamp" placeholder="Seleccione un día">
          </el-date-picker>
         	<div class="text-red margin-b-25 font-size-14" v-show="showErrorMessage && dateSearch !== null">
					*{{errorMessage}}
			  	</div>
        </el-col>
      </el-row>

      <div style="margin-top: 3rem" v-if="stateGuideSelected">
      	<p >Estado de la Guía de Programación: </p>
      </div>
      <template v-if="!loading">
        <div style="margin-top: 2rem" v-if="stateGuideSelected">
          <p class="textBold font-size-17 margin_l_35 flex" v-bind:class="[ stateGuideSelected && stateGuideSelected == 'CERRADO'  ? 'text-red-color' : 'text-green' ]" > {{ stateGuideSelected }}
          </p>
        </div>
      </template>
      <template v-else>
        <div class="loader">Loading...</div>
      </template>
      
     <el-button type="primary" plain style="float: right;"
      :disabled="isBtnDisabled == false"
      :loading="loadingButton"
      @click="btnClose(dateSearch)">
      <i class="el-icon-document"></i> CERRAR PARRILLA
      </el-button>
    </div>

		<app-modal :show-dialog.sync="modalCloseGuide" v-if="modalCloseGuide" nameClass="dialog-orange" :rutImg="require(`@/assets/images/suspicious.svg`)" sizeImg="80px" textBold="¡Un momento!" 
      :parrafo="parrafoModal" classBtn1="border-orange" typeBtn1="primary" btn1="CANCELAR" btn2="ACEPTAR" @btnEvent="modalCloseGuide = false" v-on:eventBtn="confirmacionDelCierreDeGuia(dateSearch)">
    </app-modal>
		<!-- MODAL QUE SE MUESTRA CUANDO SE HA REALIZADO CORRECTAMENTE EL CIERRE DE GUIA -->
		<AppModalSuccess :show-dialog.sync="modalSuccess" widthModal="40%"  v-if="modalSuccess" :parrafo="parrafoTextSuccess"
			btn1="OK" v-on:btnEvent="modalSuccess = false">
		</AppModalSuccess>

    <!-- ERROR AL REALIZAR EL CIERRE DE GUIA EN GEMINIS -->
    <AppModal :show-dialog.sync="errorCloseGeminis" v-if="errorCloseGeminis" nameClass="dialog-red" 
      :rutImg="require(`@/assets/images/alerta.svg`)" sizeImg="80%"  
      :parrafo="textErrorCloseGuide">
    </AppModal>

    <el-dialog :visible.sync="alertPrevToSave" width="33%" :show-close="false" custom-class="dialog-red"
          :close-on-press-escape="false" :close-on-click-modal="false"> 
      <el-row style="display: flex; align-items: center;">
        <el-col :span="5" class="text-center">
          <img :src="require(`@/assets/images/alerta.svg`)" alt="emoticon" width="80px">
        </el-col>
        <el-col :span="18" :offset="1">
          <p> Por favor, <span class="text-bold text-green"> ESPERE </span> mientras se guarda la información...</p>
        </el-col>
      </el-row>
    </el-dialog>

	</div>
</template>

<script>

import ReturnButton from '@/components/ReturnButton.vue'
import { getFirstDay } from '@/utils/calculateTime.js'
import { months } from '@/enums.js'
import { HTTP } from '@/main.js'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import { convertHourDate, changePositionFormatDayString, convertFormatDayForCrusses } from '@/utils/calculateTimePrograms.js'


export default {
	components: {
		 AppModal,
		ReturnButton,
		AppModalSuccess,
	},
	data (){
		return {
			channelTransmition: this.$localStorage.get('channelTransmition'),
			dateSearch: '',
			firstDayOfWeek: '',
			firstDay: '',
			lastDay: '',
			month: '',
			month2: '',
			year: '',
			year2: '',
			startDate: '',
			endDate: '',
			errorMessage: '',
			showErrorMessage: false,
			parrafoModal: '',
			modalCloseGuide: false,
			closingStatus: '',
			userName: '',
			userEmail: localStorage.getItem('userEmail'),
			pickerOptions: {
				disabledDate: this.disabledDate
			},
			guideClosureUpdate: [],
			modalSuccess: false,
			parrafoTextSuccess: '',
			history: [],
			programsToUpdateInOrcl: [],
			parrafoAlertText: '',
			modalCantCloseGuide: false,
			// textAlertAdvertising: '',
			modalAlertOfAdvertising: false,
			textOpenGuideFirst: '',
			modalOpenGuideFirst: false,
			allPrograms: '',
      crossesPrograms: '',
      stateGuideSelected: null,
      isBtnDisabled: false,
      infoDaySelected: {},
      allProgramsWithDay: null,
      errorCloseGeminis: false,
      textErrorCloseGuide: null,
      alertPrevToSave: false,
      loading:false,
      loadingButton:false,
		}
	},
	created () {
		this.gettingUsername()
	},
	methods: {
    async obtenerFechaInicioSemana(fechaIngresada){
      const fecha = new Date(fechaIngresada);
      const diaSemana = fecha.getDay();
      const restarDias = diaSemana==0? 6:diaSemana==1? 0:diaSemana-1;
      const fechaInicioSemana = fecha.setDate(fecha.getDate() - restarDias );
      const fechaInicio = new Date(fechaInicioSemana);

      let res = await HTTP.post('/grid/programas',{fechaInicio})
      let programas = res.data.grid && res.data.grid.length > 0 ? res.data.grid[0].programs:[]; 
      let programasDiaIngresada = programas.filter(programa=>{
        let fechaPrograma = new Date(programa.programDate);
        let fechaIngreso = new Date(fechaIngresada);
        return fechaPrograma.toString() == fechaIngreso.toString()
      })
      const testProgramas = programasDiaIngresada.map(programa=> ({titulo:programa.programGridTitle,inicio:programa.timeStart,fin:programa.timeEnd}))
      console.log({testProgramas})
      this.programsToUpdateInOrcl = programasDiaIngresada;
        
    },
		gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
		goTo(value, content) {
			if(value) {
				let obj = {type: content}
				this.$router.push({ name: value, params: obj })
			}
		},
		disabledDate(time) {
			let today = new Date()
			return time < today
    },
		getWeek() {
			let dateString = ''
			this.firstDayOfWeek = getFirstDay(new Date(this.dateSearch));
			this.startDate = getFirstDay(new Date(this.dateSearch))
			this.firstDay = this.firstDayOfWeek.getDate();
			this.lastDay = new Date(this.firstDayOfWeek.getTime() + (24*60*60*1000)*6).getDate()
			this.endDate = new Date(this.startDate.setDate(this.startDate.getDate() + 6))
			this.month = months[this.firstDayOfWeek.getMonth()];
			this.month2 = months[this.endDate.getMonth()];
			this.year = this.firstDayOfWeek.getFullYear();
			this.year2 = this.endDate.getFullYear();

			if (this.month == this.month2 && this.year == this.year2) {
				dateString = `Semana del ${this.firstDay} al ${this.lastDay} de ${this.month} del ${this.year}`
			} else if (this.month !== this.month2 && this.year == this.year2 ) {
				dateString = `Semana del ${this.firstDay} de ${this.month} al ${this.lastDay} de ${this.month2} del ${this.year}`
			} else if (this.month !== this.month2 && this.year !== this.year2) {
				dateString = `Semana del ${this.firstDay} de ${this.month} del ${this.year} al ${this.lastDay} de ${this.month2} del ${this.year2}`
			}
			return dateString
		},
		getFullDay(day) {
			let daysArr = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado']
			let dateSentence = `${daysArr[day.getDay()]} ${day.getDate()} de ${months[day.getMonth()]} del ${day.getFullYear()}`
			return dateSentence
    },
    async changeDayClose (day) {
      this.loading = true;
      await this.obtenerFechaInicioSemana(day);
      const weekSelected = this.getWeek()
      const dateSelected = new Date(day)
      const daySelect = this.getFullDay(dateSelected)
      let response = await HTTP.get(`grid/gridByDay/${weekSelected}/${daySelect}/${this.channelTransmition}`)
      console.log(response, 'response')
      
	  // VERIFICANDO SI ESTA SEMANA ESTA GENERADA EN IN_GRID
	  	if (!response.data.daySelected.message || response.data.daySelected.message && response.data.daySelected.message  == '') {

        this.allProgramsWithDay = response.data.daySelected.programsOfDay
        
        // JALANDO EL ESTADO DEL CIERRE DE ORACLE
        let changeFormatDay = changePositionFormatDayString( new Date(day).toLocaleDateString('en-GB'))
        let data = { "day": changeFormatDay , "signal": 'LI' }
        console.log(data, 'data')
        let responseState = await HTTP.post( `guideClosure/getStateGuideBySignal`, data )

        //MOSTRAR EL ESTADO
        console.log(responseState.data, 'responseState.data')
        this.stateGuideSelected = responseState.data.state == 'C' ? 'CERRADO' : 'ABIERTO'
        if (this.stateGuideSelected == 'ABIERTO'  ) {
          this.infoDaySelected = responseState.data
          this.isBtnDisabled = true
        }
        else {
          this.isBtnDisabled = false
        }
        console.log(this.stateGuideSelected, 'stateGuideSelected')
        this.loading = false;
      }
      else {
        this.stateGuideSelected = null
        this.isBtnDisabled = false
        console.log('El día seleccionado no tiene programación')
        this.textErrorCloseGuide = `<p> El día  <strong> ${ daySelect }  </strong> no tiene programación  </p>`
        this.errorCloseGeminis = true
        this.loading = false;
      }
    },
  	sortByHour(programs) {
      let newARR =  programs.sort(( a, b ) => {
        var c = convertFormatDayForCrusses( convertHourDate(a.programDate, a.scheduleStartHour, a.scheduleStartMin), a.programDate, 'start' )
        var d = convertFormatDayForCrusses( convertHourDate(b.programDate, b.scheduleStartHour, b.scheduleStartMin), b.programDate, 'start' )
        return c-d;
      })
      return newARR
    },
     btnClose ( day ) {
      const dateSelected = new Date(day)
      const daySelect = this.getFullDay(dateSelected)
      this.parrafoModal = `Se va <strong> CERRRAR LA GUÍA </strong>  de programación del  <strong>${daySelect}</strong>?`
      this.modalCloseGuide = true
    },
    checkingSpacesBetweenPrograms ( allPrograms ) {
      
      let orderByProgram = this.sortByHour( allPrograms )
      console.log(orderByProgram, 'orderByProgram')
      if (orderByProgram.length > 10) {
        let startProgram = orderByProgram[0].scheduleStartHour + ':' + orderByProgram[0].scheduleStartMin + ':00'
        let hoursStart, hoursEnd
        if (startProgram == '05:16:00') {
          let arrayDeBoleanos =  orderByProgram.map(( program, i ) => {
            
            if ( i == 0 ) {
              hoursStart = program.scheduleStartHour + ':' + program.scheduleStartMin + ':00'
              hoursEnd = program.scheduleEndHour + ':' + program.scheduleEndMin + ':00'
              return true
            }
            else {
              let start = program.scheduleStartHour + ':' + program.scheduleStartMin + ':00'
              let end = program.scheduleEndHour + ':' + program.scheduleEndMin + ':00'
              if ( start == hoursEnd ) {
                hoursEnd = end

                return true
              }
              else {
                return false
              }
            }
          }) 
          console.log(arrayDeBoleanos, 'arrayDeBoleanos')
          if (arrayDeBoleanos.includes(false)) {
            return false
  
          }
          else {
            return true
          }
        }
        else {
          return false
        }

      }
      else {
        return false
      }
    },
    async confirmacionDelCierreDeGuia (day) {
      this.modalCloseGuide = false;
      this.loadingButton = true;
    	const dateSelected = new Date(day)
      const daySelect = this.getFullDay(dateSelected)
      let objToSave = null
      let objToHistory = null

      /*VERIFICANDO SI EL PROGRAMA FINAL DEL DIA ANTERIOR ES CONSECUTIVO A LA HORA DE INICIO EN EL QUE QUIERO CERRAR*/
      const dayBefore = new Date(day-(1000*60*60*24))
      const dayBeforeSelect = dayBefore.toLocaleDateString('en-GB')
      const daySelectData = dateSelected.toLocaleDateString('en-GB')
      const response =  await HTTP.post(`grid/dayContinues`, {
        daySelect: daySelectData,
        dayBefore: dayBeforeSelect
      })
      if(response.data.result == true) {
        /* Aqui debo actualizar el time code inicio*/
        console.log(`Se ha actualizado el 1 er corte del programa: ${response.data.program}`)
      }
      console.log(response.data.result, 'response')
      
      /*VERIFICANDO SI EXISTEN ESPACIOS LIBRES ENTRE PROGRAMAS*/
      
      let existingSpacesBetweenProgramas =  this.checkingSpacesBetweenPrograms(this.allProgramsWithDay) 
      if (existingSpacesBetweenProgramas) {
        this.modalCloseGuide = false
        this.alertPrevToSave = true
        let response = await HTTP.get(`guideClosure/byDay/${daySelect}/byChannel/${this.channelTransmition}`)
        if ( response.data.count > 0 ) {
        // EXISTE EN LA BBDD MONGO - QUIERE DECIR QUE ES LA 2DA VEZ QUE SE
        //CIERRA LA GUIA DE PROGRAMACION EN IN_GRID
          this.guideClosureUpdate.push(response.data.guideClosure[0])
          objToHistory = {
            channel: this.guideClosureUpdate[0].channel,
            closedDay: this.guideClosureUpdate[0].closedDay,
            dayOfClosing: this.guideClosureUpdate[0].dayOfClosing,
            status: this.guideClosureUpdate[0].status,
            user: this.guideClosureUpdate[0].user
          }
          this.history.push(objToHistory)
        }
        else {
          //POST A MONGO- 1ER CIERRE EN IN_GRID
           objToSave = {
            closedDay: daySelect,
            status: this.closingStatus,
            channel: this.channelTransmition,
            user: this.userName,
            programs: this.allPrograms,
            programsToUpdate: this.programsToUpdateInOrcl
          }
        }
  
        // SOLO SI SE HA REALIZADO CORRECTAMENTE EL CIERRE EN GEMINIS - GUARDAR EN MONGO Y MOSTRAR MENSAJE DEL CIERRE 
        let changeFormatDay = changePositionFormatDayString( new Date(day).toLocaleDateString('en-GB'))
        let object = {
          fecha: changeFormatDay,
          stateGroup: this.infoDaySelected.groupProgramacion,
          signal: 'LI',
          usuario: this.userName
        }
        // CERRANDO LA GUIA DE PROGRAMACION EN GEMINIS
        let infoCloseGuideGeminis = await HTTP.post( `guideClosure/closeGuideInGeminis`, object )
        console.log(infoCloseGuideGeminis.data, 'infoCloseGuideGeminis')
        if (infoCloseGuideGeminis.data.status) {
          //SE REALIZO CORRECTAMENTE EL CIERRE DE GUIA EN GEMINIS - GUARDAR EN MONGODB Y MOSTRAR MODAL
          if (response.data.count > 0) {
            console.log('SEGUNDO CIERRE A MONGO')
            //segundo cierre update a mongo
              HTTP.patch(`guideClosure/byDay/${daySelect}/byChannel/${this.channelTransmition}` , [
              { propName: "status", value: this.closingStatus },
              { propName: "user", value: this.userName },
              { propName: "history", value: this.history},
              { propName: "programs", value: this.allPrograms},
              { propName: "programsToUpdate", value: this.programsToUpdateInOrcl},
              { propName: "crossesPrograms", value: this.crossesPrograms}
            ])
            .then(res => {
              this.excecuteSuccessTrue(daySelect)
              this.stateGuideSelected = 'CERRADO'
              this.loadingButton = false;
            })
            .catch(err => console.log(err))
          }
          else {
            console.log('post')
            /*post a mongodb*/
            HTTP.post(`guideClosure`, objToSave)
            .then(res=>{
              this.excecuteSuccessTrue(daySelect)
              this.stateGuideSelected = 'CERRADO'
              this.loadingButton = false;
            })
            .catch(err => console.log(err))
          }
        }
        else {
          this.modalCloseGuide = false
          this.loadingButton = false;
          // ERROR AL REALIZAR EL CIERRE DE GUIA EN GEMINIS MOSTRAR EL ERROR 
          let msjeError = 'MENSAJE DE ERROR'
          // this.excecuteSuccessTrue(daySelect, msjeError )
          // this.textErrorCloseGuide = infoCloseGuideGeminis.data.data
          this.textErrorCloseGuide = `<p> Ocurrió un  <strong> ERROR!!  </strong> al realizar la integración con el  <span class="text-red text-bold"> SISTEMA GÉMINIS </span>. No se pudo <strong> CERRAR LA GUIA DE PROGRAMACIÓN </strong></p>`
          this.alertPrevToSave = false
          this.errorCloseGeminis = true
        }

      }
      else {
        console.log('salir modal de huecos')
        this.modalCloseGuide = false
        this.loadingButton = false;
        this.textErrorCloseGuide = `<p>  La programacion del <strong> ${ daySelect } </strong> esta incompleto. Existen <span class="text-red text-bold"> ESPACIOS LIBRES </span>. Corregir antes de cerrar la <strong> GUIA DE PROGRAMACIÓN </strong></p>`
        this.errorCloseGeminis = true
      }
    },  
		excecuteSuccessTrue(day, msn ) {
			this.parrafoTextSuccess = msn ? msn : `El cierre de parrilla del día <strong>${day}</strong> se ha realizado correctamente.`
      this.modalCloseGuide = false
      this.alertPrevToSave = false
      this.modalSuccess = true
      this.isBtnDisabled = false
      
      console.log(this.isBtnDisabled, 'manipula')
		}
	}
}
</script>

<style>
.m-b-15{
	margin-bottom: 15px;
}
.loader {
  color: #ff5000;
  font-size: 20px;
  margin: 100px auto;
  width: 1em;
  height: 1em;
  border-radius: 50%;
  position: relative;
  text-indent: -9999em;
  -webkit-animation: load4 1.3s infinite linear;
  animation: load4 1.3s infinite linear;
  -webkit-transform: translateZ(0);
  -ms-transform: translateZ(0);
  transform: translateZ(0);
}
@-webkit-keyframes load4 {
  0%,
  100% {
    box-shadow: 0 -3em 0 0.2em, 2em -2em 0 0em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 -1em, -3em 0 0 -1em, -2em -2em 0 0;
  }
  12.5% {
    box-shadow: 0 -3em 0 0, 2em -2em 0 0.2em, 3em 0 0 0, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 -1em, -3em 0 0 -1em, -2em -2em 0 -1em;
  }
  25% {
    box-shadow: 0 -3em 0 -0.5em, 2em -2em 0 0, 3em 0 0 0.2em, 2em 2em 0 0, 0 3em 0 -1em, -2em 2em 0 -1em, -3em 0 0 -1em, -2em -2em 0 -1em;
  }
  37.5% {
    box-shadow: 0 -3em 0 -1em, 2em -2em 0 -1em, 3em 0em 0 0, 2em 2em 0 0.2em, 0 3em 0 0em, -2em 2em 0 -1em, -3em 0em 0 -1em, -2em -2em 0 -1em;
  }
  50% {
    box-shadow: 0 -3em 0 -1em, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 0em, 0 3em 0 0.2em, -2em 2em 0 0, -3em 0em 0 -1em, -2em -2em 0 -1em;
  }
  62.5% {
    box-shadow: 0 -3em 0 -1em, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 0, -2em 2em 0 0.2em, -3em 0 0 0, -2em -2em 0 -1em;
  }
  75% {
    box-shadow: 0em -3em 0 -1em, 2em -2em 0 -1em, 3em 0em 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 0, -3em 0em 0 0.2em, -2em -2em 0 0;
  }
  87.5% {
    box-shadow: 0em -3em 0 0, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 0, -3em 0em 0 0, -2em -2em 0 0.2em;
  }
}
@keyframes load4 {
  0%,
  100% {
    box-shadow: 0 -3em 0 0.2em, 2em -2em 0 0em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 -1em, -3em 0 0 -1em, -2em -2em 0 0;
  }
  12.5% {
    box-shadow: 0 -3em 0 0, 2em -2em 0 0.2em, 3em 0 0 0, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 -1em, -3em 0 0 -1em, -2em -2em 0 -1em;
  }
  25% {
    box-shadow: 0 -3em 0 -0.5em, 2em -2em 0 0, 3em 0 0 0.2em, 2em 2em 0 0, 0 3em 0 -1em, -2em 2em 0 -1em, -3em 0 0 -1em, -2em -2em 0 -1em;
  }
  37.5% {
    box-shadow: 0 -3em 0 -1em, 2em -2em 0 -1em, 3em 0em 0 0, 2em 2em 0 0.2em, 0 3em 0 0em, -2em 2em 0 -1em, -3em 0em 0 -1em, -2em -2em 0 -1em;
  }
  50% {
    box-shadow: 0 -3em 0 -1em, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 0em, 0 3em 0 0.2em, -2em 2em 0 0, -3em 0em 0 -1em, -2em -2em 0 -1em;
  }
  62.5% {
    box-shadow: 0 -3em 0 -1em, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 0, -2em 2em 0 0.2em, -3em 0 0 0, -2em -2em 0 -1em;
  }
  75% {
    box-shadow: 0em -3em 0 -1em, 2em -2em 0 -1em, 3em 0em 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 0, -3em 0em 0 0.2em, -2em -2em 0 0;
  }
  87.5% {
    box-shadow: 0em -3em 0 0, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 0, -3em 0em 0 0, -2em -2em 0 0.2em;
  }
}

</style>